summaryrefslogtreecommitdiff
path: root/helpers/chroot_hooks
diff options
context:
space:
mode:
authorDaniel Baumann <daniel@debian.org>2010-02-05 17:10:44 +0100
committerDaniel Baumann <daniel@debian.org>2011-03-09 19:17:04 +0100
commit3b80c5c5d9c9d2eec91910b70a120da5943c7fac (patch)
tree31b5fef2977e7fabe669077041c569169c788a95 /helpers/chroot_hooks
parent59e9a93ad08c171fb0d22e965c56f91c5bd17615 (diff)
downloadlive-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.zip
live-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.tar.gz
Dropping lh_ prefix from internal helpers, this is not user visible.
Diffstat (limited to 'helpers/chroot_hooks')
-rwxr-xr-xhelpers/chroot_hooks71
1 files changed, 71 insertions, 0 deletions
diff --git a/helpers/chroot_hooks b/helpers/chroot_hooks
new file mode 100755
index 0000000..986aab5
--- /dev/null
+++ b/helpers/chroot_hooks
@@ -0,0 +1,71 @@
+#!/bin/sh
+
+# lh_chroot_hooks(1) - execute hooks in chroot
+# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'execute hooks in chroot')"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+Echo_message "Begin executing hooks..."
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+# Checking stage file
+Check_stagefile .stage/chroot_hooks
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+# Processing hooks
+HOOKS="$(echo ${LH_HOOKS} ${LH_PACKAGES_LISTS} ${LH_TASKS} | sed -e 's| |\n|g' | sort -u)"
+
+for HOOK in ${HOOKS}
+do
+ # Special handling for kde
+ if [ "${HOOK}" = "kde-desktop" ] && [ -n "$(echo ${HOOKS} | grep gnome-desktop)" ]
+ then
+ continue
+ fi
+
+ if [ -f ${LH_BASE:-/usr/share/live-helper}/hooks/"${HOOK}" ]
+ then
+ # Copying hook
+ cp ${LH_BASE:-/usr/share/live-helper}/hooks/"${HOOK}" chroot/root
+
+ # Making hook executable
+ if [ ! -x chroot/root/"${HOOK}" ]
+ then
+ chmod +x chroot/root/"${HOOK}"
+ fi
+
+ # Executing hook
+ Chroot chroot "./root/${HOOK}" || ( Echo_error "${HOOK} failed (exit non-zero). You should check for errors."; exit 1 )
+
+ # Removing hook
+ rm -f chroot/root/"${HOOK}"
+
+ # Creating stage file
+ Create_stagefile .stage/chroot_hooks
+ fi
+done